from binheap import binheap


def partition(A, lbound, rbound, pivot):
    # sposto il pivot all'inizio
    A[pivot], A[lbound] = A[lbound], A[pivot]
    pivot = lbound

    # metto i valori della finestra
    # in S e G
    i, j = pivot+1, rbound-1
    while i <= j:
        if A[i] <= A[pivot]:
            i += 1
        else:
            A[i], A[j] = A[j], A[i]
            j -= 1


    # Sposto il pivot nella sua 
    # posizione corretta
    A[j], A[pivot] = A[pivot], A[j]

    return j


def quicksort(A, lbound=0, rbound=None):
    if rbound is None:
        rbound = len(A)

    if lbound < rbound-1:
        pivot = partition(A, lbound, rbound, lbound)

        quicksort(A, lbound=lbound, rbound=pivot)
        quicksort(A, lbound=pivot+1, rbound=rbound)


def quicksort_no_tail(A, lbound=0, rbound=None):
    if rbound is None:
        rbound = len(A)

    while lbound < rbound-1:
        pivot = partition(A, lbound, rbound, lbound)

        quicksort_no_tail(A, lbound=lbound, rbound=pivot)
        lbound = pivot+1


def max_order(a, b):
    return a >= b


def heapsort(A):
    H = binheap(A, total_order=max_order)

    for i in range(len(A)-1, -1, -1):
        A[i] = H.delete_min()


def counting_sort(A):
    max_in_domain = max(A)

    C = [0]*(max_in_domain+1)

    # conto il numero di ripetizioni 
    # dei valori in A
    for value in A:
        C[value] += 1

    # conto il numero di valori in A 
    # <= all'indice di C
    for i in range(0, max_in_domain):
        C[i+1] += C[i]

    B = [0] * len(A)
    for j in range(len(A)-1, -1, -1):
        # minori_di_A_j = C[A[j]]
        # B[minori_di_A-1] = A[j]

        C[A[j]] -= 1
        B[C[A[j]]] = A[j]

    return B
